=== debian/changelog ===
xeus-gp (0.0.0-1) unstable; urgency=medium

  * Initial release.

 -- Bill Allombert <ballombe@debian.org>  Tue, 15 Oct 2024 14:11:46 +0200
