=== debian/control ===
Source: xeus-gp
Priority: optional
Maintainer: Bill Allombert <ballombe@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               libzmq3-dev,
               xeus-zmq-dev (>= 1.1.1-2~),
               xtl-dev (>= 0.7~),
               nlohmann-json3-dev (>= 3.11.3~),
               libpari-dev,
               libreadline-dev
Standards-Version: 4.7.0
Section: math
Homepage: https://pari.math.u-bordeaux.fr/
Rules-Requires-Root: no

Package: xeus-gp
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: Native jupyter kernel for GP
 xeus-gp uses the xeus library to provide a high-performance,
 native kernel for running GP code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the xgp executable and jupyter kernel configuration.
