## xeus-gp 0.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # with the package; see the file 'COPYING'. If not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 project(xeus-gp)
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
 
@@ -61,7 +61,8 @@
 # ============
 
 set(xtl_REQUIRED_VERSION 0.7.0)
-set(xeus_REQUIRED_VERSION 3.0.5)
+set(xeus_REQUIRED_VERSION 5.0.0)
+set(xeus-zmq_REQUIRED_VERSION 3.0.0)
 
 if (NOT TARGET xtl)
     find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
@@ -83,11 +84,11 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder")
     
 
-    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP_14_FLAG)
-    if (HAS_CPP_14_FLAG)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
-    else ()
-        message(FATAL_ERROR "Unsupported compiler -- xeus requires C++14 support!")
+    CHECK_CXX_COMPILER_FLAG("-std=c++17" HAS_CPP_17_FLAG)
+    if (HAS_CPP_17_FLAG)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
+    else ()
+        message(FATAL_ERROR "Unsupported compiler -- xeus requires C++17 support!")
     endif ()
 endif ()
 
@@ -245,7 +246,7 @@
 # xeus-gp
 # =======
 if (XEUS_GP_BUILD_EXECUTABLE)
-    find_package(xeus-zmq 1.0.2 REQUIRED)
+    find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
     add_executable(xeus-gp ${XEUS_GP_MAIN_SRC})
     target_compile_features(xeus-gp PRIVATE cxx_std_14)
     xeus_gp_set_common_options(xeus-gp)
@@ -326,6 +327,8 @@
   endif ()
 endif ()
 
+install(FILES xeus-gp.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
+
 # Build tarball from git
 
 set(ARCHIVE_NAME ${PROJECT_NAME}-${${PROJECT_NAME}_VERSION})
