=== debian/changelog ===
xeus-gp (0.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/xeus-gp.1, debian/manpages: merged upstream
  * debian/control:
    - Add Build-Depends  xeus-dev (>= 5.0~), xeus-zmq-dev (>= 3.0~)

 -- Bill Allombert <ballombe@debian.org>  Sat, 28 Dec 2024 21:10:20 +0100

xeus-gp (0.0.0-2) unstable; urgency=medium

  * Source-only upload.

 -- Bill Allombert <ballombe@debian.org>  Sun, 22 Dec 2024 14:29:25 +0100
