=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
                cmake,
                pkgconf,
                libzmq3-dev,
-               xeus-zmq-dev (>= 1.1.1-2~),
+               xeus-dev (>= 5.0~),
+               xeus-zmq-dev (>= 3.0~),
                xtl-dev (>= 0.7~),
                nlohmann-json3-dev (>= 3.11.3~),
                libpari-dev,
