## xeus-gp 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # with the package; see the file 'COPYING'. If not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.10.0)
 project(xeus-gp)
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
 
@@ -60,16 +60,11 @@
 # Dependencies
 # ============
 
-set(xtl_REQUIRED_VERSION 0.7.0)
+
 set(xeus_REQUIRED_VERSION 5.0.0)
 set(xeus-zmq_REQUIRED_VERSION 3.0.0)
 
-if (NOT TARGET xtl)
-    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
-endif ()
-if (NOT TARGET xeus AND NOT TARGET xeus-static)
-    find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
-endif ()
+find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
 
 # Flags
 # =====
@@ -132,12 +127,12 @@
 
         target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
 
-        # C++14 flag
-        CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP_14_FLAG)
-        if (HAS_CPP_14_FLAG)
-            target_compile_features(${target_name} PRIVATE cxx_std_14)
+        # C++17 flag
+        CHECK_CXX_COMPILER_FLAG("-std=c++17" HAS_CPP_17_FLAG)
+        if (HAS_CPP_17_FLAG)
+            target_compile_features(${target_name} PRIVATE cxx_std_17)
         else ()
-            message(FATAL_ERROR "Unsupported compiler -- xeus-gp requires C++14 support!")
+            message(FATAL_ERROR "Unsupported compiler -- xeus-gp requires C++17 support!")
         endif ()
     endif ()
 
@@ -168,7 +163,7 @@
         target_link_libraries(${target_name} PRIVATE xeus-gp-static)
     endif()
 
-    find_package(Threads) 
+    find_package(Threads)
         target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
     
 endmacro()
@@ -193,7 +188,7 @@
 
     target_compile_definitions(${target_name} PUBLIC "XEUS_GP_EXPORTS")
 
-    target_compile_features(${target_name} PRIVATE cxx_std_14)
+    target_compile_features(${target_name} PRIVATE cxx_std_17)
 
     target_include_directories(${target_name}
                                PUBLIC
@@ -206,7 +201,7 @@
         set(XEUS_GP_XEUS_TARGET xeus-static)
     endif ()
 
-    target_link_libraries(${target_name} PUBLIC ${XEUS_GP_XEUS_TARGET} xtl)
+    target_link_libraries(${target_name} PUBLIC ${XEUS_GP_XEUS_TARGET})
     if (WIN32 OR CYGWIN)
         #
     elseif (APPLE)
@@ -248,7 +243,7 @@
 if (XEUS_GP_BUILD_EXECUTABLE)
     find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
     add_executable(xeus-gp ${XEUS_GP_MAIN_SRC})
-    target_compile_features(xeus-gp PRIVATE cxx_std_14)
+    target_compile_features(xeus-gp PRIVATE cxx_std_17)
     xeus_gp_set_common_options(xeus-gp)
     xeus_gp_set_kernel_options(xeus-gp)
     target_link_libraries(xeus-gp PRIVATE xeus-zmq)
