=== debian/changelog ===
xeus-gp (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: use version=4
  * debian/control:
   - Remove Build-Depends on xtl-dev
   - Build-Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev
   - Bump Standards-Version to 4.7.2

 -- Bill Allombert <ballombe@debian.org>  Sun, 02 Nov 2025 18:58:21 +0100
