=== debian/control ===
--- 
+++ 
@@ -7,11 +7,10 @@
                libzmq3-dev,
                xeus-dev (>= 5.0~),
                xeus-zmq-dev (>= 3.0~),
-               xtl-dev (>= 0.7~),
-               nlohmann-json3-dev (>= 3.11.3~),
+               nlohmann-json3.12-dev,
                libpari-dev,
                libreadline-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: math
 Homepage: https://pari.math.u-bordeaux.fr/
 Rules-Requires-Root: no
