=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=ON
+
+execute_before_dh_clean:
+	rm -f share/jupyter/kernels/xeus-gp/kernel.json
